library verilog;
use verilog.vl_types.all;
entity key_generator is
    generic(
        init1           : integer := 0;
        init2           : integer := 1;
        init3           : integer := 2;
        transfer1       : integer := 3;
        transfer2       : integer := 4;
        transfer3       : integer := 5;
        transfer4       : integer := 6;
        update          : integer := 7;
        dummy           : integer := 8;
        assert_done     : integer := 9
    );
    port(
        clk             : in     vl_logic;
        reset           : in     vl_logic;
        initial_key     : in     vl_logic;
        keys            : out    vl_logic;
        key_gen_done    : out    vl_logic
    );
end key_generator;
